package com.woolha.spring.springbeanregistration.config;

import com.woolha.spring.springbeanregistration.bean.MyComponent;
import org.springframework.beans.factory.support.BeanDefinitionBuilder;
import org.springframework.beans.factory.support.DefaultListableBeanFactory;
import org.springframework.beans.factory.support.GenericBeanDefinition;
import org.springframework.context.annotation.Configuration;

@Configuration
public class BazConfig {

  public BazConfig(DefaultListableBeanFactory beanFactory) {
    GenericBeanDefinition gbd = new GenericBeanDefinition();
    gbd.setBeanClass(MyComponent.class);
    gbd.getConstructorArgumentValues()
        .addIndexedArgumentValue(0, "baz1");
    beanFactory.registerBeanDefinition("bazComponent1", gbd);

    BeanDefinitionBuilder bdb = BeanDefinitionBuilder.rootBeanDefinition(MyComponent.class)
        .addConstructorArgValue("baz2");
    beanFactory.registerBeanDefinition("bazComponent2", bdb.getBeanDefinition());
  }
}
