package com.woolha.spring.springbeanregistration.config;

import com.woolha.spring.springbeanregistration.bean.MyComponent;
import org.springframework.beans.BeansException;
import org.springframework.beans.factory.config.ConfigurableListableBeanFactory;
import org.springframework.beans.factory.support.BeanDefinitionRegistry;
import org.springframework.beans.factory.support.BeanDefinitionRegistryPostProcessor;
import org.springframework.beans.factory.support.GenericBeanDefinition;
import org.springframework.context.annotation.Configuration;

@Configuration
public class CorgeConfig implements BeanDefinitionRegistryPostProcessor {

  @Override
  public void postProcessBeanDefinitionRegistry(BeanDefinitionRegistry registry) throws BeansException {
    GenericBeanDefinition gbd = new GenericBeanDefinition();
    gbd.setBeanClass(MyComponent.class);
    gbd.getConstructorArgumentValues().addIndexedArgumentValue(0, "corge");
    registry.registerBeanDefinition("corgeComponent", gbd);
  }

  @Override
  public void postProcessBeanFactory(ConfigurableListableBeanFactory beanFactory) throws BeansException {
    // Empty
    System.out.println("xxx");
  }
}
