package com.woolha.spring.springbeanregistration.config;

import com.woolha.spring.springbeanregistration.bean.MyComponent;
import org.springframework.beans.BeansException;
import org.springframework.beans.factory.config.BeanFactoryPostProcessor;
import org.springframework.beans.factory.config.ConfigurableListableBeanFactory;
import org.springframework.beans.factory.support.DefaultListableBeanFactory;
import org.springframework.beans.factory.support.GenericBeanDefinition;
import org.springframework.context.annotation.Configuration;

@Configuration
public class QuxConfig implements BeanFactoryPostProcessor {

  @Override
  public void postProcessBeanFactory(ConfigurableListableBeanFactory beanFactory) throws BeansException {
    GenericBeanDefinition gbd = new GenericBeanDefinition();
    gbd.setBeanClass(MyComponent.class);
    gbd.getConstructorArgumentValues().addIndexedArgumentValue(0, "qux");

    ((DefaultListableBeanFactory) beanFactory).registerBeanDefinition("quxComponent", gbd);
  }
}
